/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   ftp.h                                              :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: jmoiroux <jmoiroux@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2014/05/12 12:15:23 by jmoiroux          #+#    #+#             */
/*   Updated: 2014/05/12 12:16:05 by jmoiroux         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#ifndef FTP_H
# define FTP_H

# include "../libft/includes/libft.h"
# include <sys/types.h>
# include <sys/socket.h>
# include <netdb.h>
# include <netinet/in.h>
# include <arpa/inet.h>
# include <dirent.h>

# define SOCKBUFF			1024
# define PROMPT				"FTP::$> "

enum						e_type
{
	E_MESSAGE,
	E_ERROR,
	E_FILE,
	E_SIGNAL,
};

typedef struct				s_clientdata
{
	char					*m_buff;
	char					*toconnect;
	char					buff[SOCKBUFF];
	char					c;
	char					confirm[SOCKBUFF];
	int						fd;
	int						file_size;
	int						ret;
	int						rt;
	int						sock;
	int						succ;
	int						openlocal;
	int						opendist;
	struct protoent			*proto;
	struct sockaddr_in		ad_cli;
}							t_clientdata;

int							ft_getfile_client(t_clientdata *d, char *line);
void						ft_getfile_client2(t_clientdata *d, char **tmp);
int							ft_getfile_client3(t_clientdata *d, char **tmp);
int							ft_putfile_client(t_clientdata *d, char *line);
void						ft_putfile_client2(t_clientdata *d, char **tmp);
int							ft_putfile_client3(t_clientdata *d, char **tmp);
void						ft_putfile_client4(t_clientdata *d);
int							init_client(t_clientdata *d, char **av);
int							prt_err(char *str);
int							recv_sock(char **buff, int sock, char *file);
int							send_sock(char *str, int sock,
									int type, char *file);
int							client_exit(t_clientdata *d);
int							client_check_cmd(t_clientdata *d);
void						client_ft_get(t_clientdata *d);
void						client_ft_put(t_clientdata *d);
void						client_ft_pwd(t_clientdata *d);
void						client_ft_cd(t_clientdata *d);
void						client_ft_ls(t_clientdata *d);

#endif

