/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   ftp.h                                              :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: jmoiroux <jmoiroux@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2014/05/12 12:15:23 by jmoiroux          #+#    #+#             */
/*   Updated: 2014/05/12 12:16:05 by jmoiroux         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#ifndef FTP_H
# define FTP_H

# include "../libft/includes/libft.h"
# include <sys/types.h>
# include <sys/socket.h>
# include <netdb.h>
# include <netinet/in.h>
# include <arpa/inet.h>
# include <dirent.h>

# define SOCKBUFF			1024
# define PROMPT				"FTP::$> "

enum						e_type
{
	E_MESSAGE,
	E_ERROR,
	E_FILE,
	E_SIGNAL,
};

typedef struct				s_serverdata
{
	char					**env;
	char					*m_buff;
	char					c;
	char					hostname[150];
	char					line[SOCKBUFF];
	char					*pwd;
	char					*oldpwd;
	char					*home;
	char					*tmp;
	int						father;
	int						port_nbr;
	int						ret;
	int						soc_new_cli;
	int						sock;
	int						fd;
	int						file_size;
	int						port_int;
	int						rt;
	int						openlocal;
	int						opendist;
	socklen_t				client_len;
	DIR						*dir;
	struct hostent			*host;
	struct protoent			*proto;
	struct sockaddr_in		ad_cli;
	struct sockaddr_in		ad_serv;
}							t_serverdata;

char						*env_getline(char **env, char *var);
int							server_check_cmd(t_serverdata *d);
int							env_setenv(char **env, char *var, char *value);
int							ft_cd(t_serverdata *d, char *line);
int							ft_cd2(t_serverdata *d, char *line);
int							ft_cd3(t_serverdata *d, char *line);
int							ft_cd4(t_serverdata *d, char *line);
int							ft_cd__(t_serverdata *d);
int							ft_cd__2(t_serverdata *d);
int							ft_cd__3(t_serverdata *d);
int							ft_cd__4(t_serverdata *d);
int							ft_cdonly(t_serverdata *d);
int							ft_cdpath(t_serverdata *d, char *line);
int							ft_getfile_server(t_serverdata *d, char *line);
void						ft_getfile_server2(t_serverdata *d, char **tmp);
int							ft_getfile_server3(t_serverdata *d, char **tmp);
void						ft_getfile_server4(t_serverdata *d);
int							ft_ls(t_serverdata *d);
int							ft_pwd(t_serverdata *d);
int							init_server(t_serverdata *d, char **av, char **env);
int							prt_err(char *str);
int							send_sock(char *str,
								int sock, int type, char *file);
int							recv_sock(char **buff, int sock, char *file);
int							server_exit(t_serverdata *d);
int							env_init(t_serverdata *d, char **env);
int							ft_putfile_server(t_serverdata *d, char *line);
void						ft_putfile_server2(t_serverdata *d, char **tmp);
int							ft_putfile_server3(t_serverdata *d, char **tmp);

#endif
