/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   function_cdpath.c                                  :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: jmoiroux <jmoiroux@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2014/05/16 11:17:22 by jmoiroux          #+#    #+#             */
/*   Updated: 2014/05/16 11:17:28 by jmoiroux         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "ftp.h"

int		ft_cdpath(t_serverdata *d, char *line)
{
	char	**tmp;
	char	*vartmp;

	tmp = ft_strsplit(line, ' ');
	tmp[1][ft_strlen(tmp[1]) - 1] = '\0';
	if ((d->pwd = env_getline(d->env, "PWD")) == NULL
		|| (d->oldpwd = env_getline(d->env, "OLDPWD")) == NULL
		|| (d->home = env_getline(d->env, "HOME")) == NULL)
		return (prt_err("env_getline error on ft_cdpath\n"));
	vartmp = ft_strjoin(&d->pwd[4], ft_strjoin("/", tmp[1]));
	if ((d->dir = opendir(vartmp)) == NULL)
		return (prt_err("Directory open error\n"));
	else
	{
		closedir(d->dir);
		if (chdir(vartmp) < 0)
			return (prt_err("chdir error on ft_cdpath\n"));
		if (env_setenv(d->env, "OLDPWD", &d->pwd[4]) < 0
			|| env_setenv(d->env, "PWD", vartmp) < 0)
			return (prt_err("Setenv error on ft_cdpath\n"));
	}
	ft_memdel((void **)&tmp[0]);
	ft_memdel((void **)&tmp[1]);
	ft_memdel((void **)&tmp);
	return (0);
}
