/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   function_getfile_server.c                          :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: jmoiroux <jmoiroux@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2014/05/15 15:13:41 by jmoiroux          #+#    #+#             */
/*   Updated: 2014/05/15 15:13:47 by jmoiroux         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "ftp.h"

int		ft_getfile_server(t_serverdata *d, char *line)
{
	char	**tmp;

	tmp = ft_strsplit(line, ' ');
	tmp[1][ft_strlen(tmp[1]) - 1] = '\0';
	ft_getfile_server2(d, tmp);
	if (ft_getfile_server3(d, tmp) < 0)
		return (-1);
	ft_getfile_server4(d);
	return (0);
}

void	ft_getfile_server2(t_serverdata *d, char **tmp)
{
	char	*norminette;

	(void)norminette;
	d->opendist = 0;
	d->openlocal = 0;
	if ((d->fd = open(tmp[1], O_RDONLY)) < 0)
	{
		d->openlocal = 0;
		send_sock("ErrorFileOpen", d->soc_new_cli, E_ERROR, NULL);
	}
	else
	{
		d->openlocal = 1;
		send_sock("FileOpenSuccess", d->soc_new_cli, E_ERROR, NULL);
	}
	recv_sock(&d->m_buff, d->soc_new_cli, NULL);
	if (ft_strnequ(d->m_buff, "ErrorFileOpen", 13) == 1)
	{
		d->opendist = 0;
	}
	else
	{
		d->opendist = 1;
	}
	ft_memdel((void **)&d->m_buff);
}

int		ft_getfile_server3(t_serverdata *d, char **tmp)
{
	char	*norminette;

	(void)norminette;
	if (d->opendist == 0 || d->openlocal == 0)
	{
		if (d->fd > 0)
			close(d->fd);
		return (prt_err("Get: File open error\n"));
	}
	d->file_size = 0;
	d->rt = 1;
	while (d->rt > 0)
	{
		d->m_buff = ft_strnew(SOCKBUFF);
		d->rt = read(d->fd, d->m_buff, SOCKBUFF);
		d->file_size = d->file_size + d->rt;
		ft_memdel((void **)&d->m_buff);
	}
	close(d->fd);
	send(d->soc_new_cli, &d->file_size, sizeof(int), 0);
	if ((d->fd = open(tmp[1], O_RDONLY)) < 0)
		return (prt_err("Get: File open error\n"));
	return (0);
}

void	ft_getfile_server4(t_serverdata *d)
{
	int		i;
	int		len;

	d->rt = 1;
	i = 0;
	while (i < d->file_size && d->rt > 0)
	{
		d->m_buff = ft_strnew(SOCKBUFF);
		d->rt = read(d->fd, d->m_buff, SOCKBUFF - 1);
		d->m_buff[d->rt] = '\0';
		if (d->rt > 0)
		{
			len = ft_strlen(d->m_buff);
			send(d->soc_new_cli, &len, sizeof(int), 0);
			d->rt = write(d->soc_new_cli, d->m_buff, ft_strlen(d->m_buff));
		}
		ft_memdel((void **)&d->m_buff);
		i = i + d->rt;
	}
	close(d->fd);
}
