/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   function_putfile_server.c                          :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: jmoiroux <jmoiroux@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2014/05/15 17:43:47 by jmoiroux          #+#    #+#             */
/*   Updated: 2014/05/15 17:44:07 by jmoiroux         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "ftp.h"

int		ft_putfile_server(t_serverdata *d, char *line)
{
	char	**tmp;

	tmp = ft_strsplit(line, ' ');
	tmp[1][ft_strlen(tmp[1]) - 1] = '\0';
	ft_putfile_server2(d, tmp);
	if (d->opendist == 0 || d->openlocal == 0)
	{
		if (d->fd > 0)
			close(d->fd);
		return (prt_err("Get: File open error\n"));
	}
	close(d->fd);
	if (ft_putfile_server3(d, tmp) < 0)
		return (-1);
	return (0);
}

void	ft_putfile_server2(t_serverdata *d, char **tmp)
{
	char	*norminette;

	(void)norminette;
	d->opendist = 0;
	d->openlocal = 0;
	if ((d->fd = open(tmp[1], O_RDWR | O_CREAT | O_TRUNC, 0777)) < 0)
	{
		d->openlocal = 0;
		send_sock("ErrorFileOpen", d->soc_new_cli, E_ERROR, NULL);
	}
	else
	{
		d->openlocal = 1;
		send_sock("FileOpenSuccess", d->soc_new_cli, E_ERROR, NULL);
	}
	recv_sock(&d->m_buff, d->soc_new_cli, NULL);
	if (ft_strnequ(d->m_buff, "ErrorFileOpen", 13) == 1)
		d->opendist = 0;
	else
		d->opendist = 1;
	ft_memdel((void **)&d->m_buff);
}

int		ft_putfile_server3(t_serverdata *d, char **tmp)
{
	int		i;
	int		len;

	if ((d->fd = open(tmp[1], O_RDWR | O_CREAT | O_TRUNC, 0777)) < 0)
		return (prt_err("Get: File open error on client\n"));
	recv(d->soc_new_cli, &d->file_size, sizeof(int), 0);
	d->rt = 1;
	i = 0;
	while (i < d->file_size && d->rt > 0)
	{
		recv(d->soc_new_cli, &len, sizeof(int), 0);
		d->m_buff = ft_strnew(len);
		d->rt = read(d->soc_new_cli, d->m_buff, len);
		if (d->rt > 0)
			write(d->fd, d->m_buff, len);
		i = i + d->rt;
		ft_memdel((void **)&d->m_buff);
	}
	close(d->fd);
	return (0);
}
