/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   server_init.c                                      :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: jmoiroux <jmoiroux@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2014/05/13 14:08:15 by jmoiroux          #+#    #+#             */
/*   Updated: 2014/05/13 14:08:21 by jmoiroux         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "ftp.h"

int		init_server(t_serverdata *d, char **av, char **env)
{
	if ((d->proto = getprotobyname("tcp")) == NULL)
		return (prt_err("TCP protocol error\n"));
	if ((d->sock = socket(PF_INET, SOCK_STREAM, d->proto->p_proto)) < 0)
		return (prt_err("Socket open error\n"));
	if (ft_atoi(av[1]) < 0 || ft_atoi(av[1]) > 65535)
		return (prt_err("port must bes between 1 - 65535\n"));
	d->port_int = ft_atoi(av[1]);
	d->ad_serv.sin_family = AF_INET;
	d->ad_serv.sin_port = htons(ft_atoi(av[1]));
	d->ad_serv.sin_addr.s_addr = htonl(INADDR_ANY);
	if (env_init(d, env) < 0)
		return (prt_err("Error on env_init\n"));
	if ((bind(d->sock, (const struct sockaddr *)&d->ad_serv,
		sizeof(d->ad_serv))) < 0)
		return (prt_err("Bind error / socket already used\n"));
	if (listen(d->sock, 42) == -1)
		return (prt_err("listening set error\n"));
	return (0);
}
