/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   server_main.c                                      :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: jmoiroux <jmoiroux@student.42.fr>          +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2014/05/12 12:14:44 by jmoiroux          #+#    #+#             */
/*   Updated: 2014/05/12 12:15:01 by jmoiroux         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "ftp.h"

int		main(int ac, char **av, char **env)
{
	t_serverdata	*d;

	if (ac != 2)
		return (prt_err("Usage: 'serveur <port>' only\n"));
	if (env[0] == NULL)
		return (prt_err("Environ NULL, retry with a environ\n"));
	if ((d = (t_serverdata *)malloc(sizeof(t_serverdata))) == NULL)
		return (prt_err("Server Malloc error\n"));
	if (init_server(d, av, env) == -1)
		return (-1);
	if ((d->soc_new_cli = accept(d->sock,
		(struct sockaddr *)&d->ad_cli, &d->client_len)) == -1)
		return (prt_err("Accept new client error\n"));
	ft_strclr(d->line);
	while ((d->ret = read(d->soc_new_cli, d->line, SOCKBUFF - 1)) > 0)
	{
		if (server_check_cmd(d) < 0)
			break ;
	}
	return (server_exit(d));
}
